
'-----------------------------------------------------------------------------
'-----------------------------------------------------------------------------
' Projekt: Lauftext fr Schlitten und andere Anwendungen mit 16 lEDs
'-----------------------------------------------------------------------------
'-----------------------------------------------------------------------------
'  Entwickler:   Sander electronic, 10245 Berlin
'                www.sander-electronic.de
'                info@sander-electronic.de
'  Release:      1.0
'-----------------------------------------------------------------------------



$regfile = "m8def.dat"
$crystal = 8000000

$hwstack = 14
$swstack = 16
$framesize = 32

' Clockdivision = 0


' Konfiguration der Ports als Ausgang in 3 Varianten
Config Portd = Output                                       ' gesamtes Port als Ausgnge
Config Portb.0 = Output                                     ' Bit 0 und 1 als Ausgnge
Config Portb.1 = Output
Ddrc = &B000111111                                          ' Port C ber Register Pin 0 ...5 als Ausgnge


Dim Timerpreload As Word                                    ' Voreinstellung des Timers

Dim I As Word                                               ' Zahl der anzuzeigenden Spalte
Dim Imax As Word                                            ' maximale Zahl der anzuzeigenden Spalten

Imax = 29                                                   ' in diesem Beispielprogramm 30 nacheinander
                                                            ' angezeigte Spalten, beginnend bei 0

Dim Ledspo As Byte                                          ' Led Spalte oberer Teil
Dim Ledspu As Byte                                          ' Led Spalte unterer Teil


' Timer einstellen

Config Timer1 = Timer , Prescale = 256
Enable Timer1


Timerpreload = 62411                                        '  Timerwert einstellen je nach Anwendung

On Timer1 Timer1_interrupt

' Interrupt erlauben
'Enable Interrupts

' LEDs ausschalten
Portb = &HFF
Portc = &HFF
Portd = &HFF


'------------------------------
' Hauptprogramm Endlosschleife
'------------------------------


Do

Waitms 10

Loop



End

'----------------------
' Unterprogramme
'----------------------
' Timer Interrupt

Timer1_interrupt:

   Ledspo = Lookup(i , Oben)                                ' Daten aus Tabelle lesen
   Ledspu = Lookup(i , Unten)

   Portc.0 = Ledspo.0                                       ' LEDs schalten
   Portc.1 = Ledspo.1
   Portc.2 = Ledspo.2
   Portc.3 = Ledspo.3
   Portc.4 = Ledspo.4
   Portc.5 = Ledspo.5
   Portd.0 = Ledspo.6
   Portd.1 = Ledspo.7
   Portd.2 = Ledspu.0
   Portd.3 = Ledspu.1
   Portd.4 = Ledspu.2
   Portd.5 = Ledspu.3
   Portd.6 = Ledspu.4
   Portd.7 = Ledspu.5
   Portb.0 = Ledspu.6
   Portb.1 = Ledspu.7


   I = I + 1
   If I = Imax Then I = 0

   If Imax = 0 Then                                         ' nach jedem Ablauf Pause durch Timerunterbrechnung
      Disable Timer1
      Waitms 1500
      Enable Timer1
   End If

   Timer1 = Timerpreload

Return

'----------------------

' Tabelle fr anzuzeigende Daten
' Zuordnung LED-Nr.zu Bytes einer Spalte
' Byte1              Byte 2
' 0 0 0 0 0 0 0 1    0 0 0 0 0 0 1 0
' Led8 . . . Led1    Led16 . . . Led9
' Teilspalte  oben     Teilspalte unten


Oben:                                                       ' LED 1 ...8
Data &B00000000 , &B11110111 , &B11110111 , &B11110111 , &B00000000
Data &B11111111 , &B00000011 , &B11101101 , &B11101110 , &B11101101
Data &B00000011 , &B11111111 , &B00000000 , &B01111111 , &B01111111
Data &B01111111 , &B11111111 , &B11111111 , &B00000000 , &B01111111
Data &B01111111 , &B01111111 , &B11111111 , &B11111111 , &B10000001
Data &B01111110 , &B01111110 , &B01111110 , &B10000001 , &B11111111



Unten:                                                      ' LED 9 ... 16
Data &B01111111 , &B01111111 , &B01111111 , &B10111111 , &B11011111
Data &B11101111 , &B11110111 , &B11111011 , &B11111011 , &B11111011
Data &B11110111 , &B11101111 , &B11011111 , &B10111111 , &B01111111
Data &B01111111 , &B10111111 , &B11011111 , &B11101111 , &B11110111
Data &B11111011 , &B11111011 , &B11111011 , &B11110111 , &B11101111
Data &B11011111 , &B10111111 , &B01111111 , &B01111111 , &B01111111





